Index: trunk/NEMOGCM/NEMO/TOP_SRC/C14b/trcini_c14b.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/C14b/trcini_c14b.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/C14b/trcini_c14b.F90	(revision 2715)
@@ -4,6 +4,6 @@
    !! TOP :   initialisation of the C14 bomb tracer
    !!======================================================================
-   !! History : Original ! 2005-10  (Z. Lachkar) 
-   !!               2.0  ! 2007-12  (C. Ethe ) 
+   !! History :  1.0  ! 2005-10  (Z. Lachkar) Original code
+   !!            2.0  ! 2007-12  (C. Ethe) 
    !!----------------------------------------------------------------------
 #if defined key_c14b
@@ -17,5 +17,4 @@
    USE trc             ! TOP variables
    USE trcsms_c14b     ! C14 sms trends
-   USE in_out_manager  ! I/O manager
 
    IMPLICIT NONE
@@ -24,26 +23,21 @@
    PUBLIC   trc_ini_c14b   ! called by trcini.F90 module
 
-   INTEGER  ::   &     ! With respect to data file !!
-     jpybeg = 1765 , & !: starting year for C14
-     jpyend = 2002     !: ending year for C14
-
-   INTEGER  ::   &   
-      nrec   ,  & ! number of year in CO2 Concentrations file
-      nmaxrec 
-
-   INTEGER  ::   inum1, inum2               ! unit number
-
-   REAL(wp) ::     &
-     ys40 = -40. ,    &             ! 40 degrees south
-     ys20 = -20. ,    &             ! 20 degrees south
-     yn20 =  20. ,    &             ! 20 degrees north
-     yn40 =  40.                    ! 40 degrees north
-
-   !!---------------------------------------------------------------------
+   !                             ! With respect to data file !!
+   INTEGER  ::   jpybeg = 1765   ! starting year for C14
+   INTEGER  ::   jpyend = 2002   ! ending year for C14
+   INTEGER  ::   nrec            ! number of year in CO2 Concentrations file
+   INTEGER  ::   nmaxrec 
+   INTEGER  ::   inum1, inum2    ! unit number
+
+   REAL(wp) ::   ys40 = -40.     ! 40 degrees south
+   REAL(wp) ::   ys20 = -20.     ! 20 degrees south
+   REAL(wp) ::   yn20 =  20.     ! 20 degrees north
+   REAL(wp) ::   yn40 =  40.     ! 40 degrees north
+
+   !!----------------------------------------------------------------------
    !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
-
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -59,6 +53,8 @@
       !!----------------------------------------------------------------------
 
-      !  Control consitency
-      CALL trc_ctl_c14b
+      !                     ! Allocate C14b arrays
+      IF( trc_sms_c14b_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'trc_ini_c14b : unable to allocate C14b arrays' )
+
+      CALL trc_ctl_c14b     !  Control consitency
 
       IF(lwp) WRITE(numout,*) ''
@@ -69,5 +65,5 @@
       ! Initialization of boundaries conditions
       ! --------------------------------------- 
-      qtr_c14(:,:) = 0.e0
+      qtr_c14(:,:) = 0._wp
       
       ! Initialization of qint in case of  no restart 
@@ -78,6 +74,6 @@
             WRITE(numout,*) 'Initialization de qint ; No restart : qint equal zero '
          ENDIF
-         trn     (:,:,:,jpc14) = 0.e0
-         qint_c14(:,:        ) = 0.e0
+         trn     (:,:,:,jpc14) = 0._wp
+         qint_c14(:,:        ) = 0._wp
       ENDIF
 
@@ -156,13 +152,13 @@
                  fareaz(ji,jj,3) = 0.
             ENDIF
-          END DO
-        END DO
-
+         END DO
+      END DO
       !
       IF(lwp) WRITE(numout,*) 'Initialization of C14 bomb tracer done'
       IF(lwp) WRITE(numout,*) ' '
-
+      !
    END SUBROUTINE trc_ini_c14b
-   
+
+
    SUBROUTINE trc_ctl_c14b
       !!----------------------------------------------------------------------
@@ -179,11 +175,11 @@
       ! Check number of tracers
       ! -----------------------   
-      IF( jp_c14b > 1) CALL ctl_stop( ' Change jp_c14b to be equal 1 in par_c14b.F90' )
+      IF( jp_c14b > 1)   CALL ctl_stop( ' Change jp_c14b to be equal 1 in par_c14b.F90' )
 
       ! Check tracer names
       ! ------------------
-      IF ( ctrcnm(jpc14) /= 'C14B' ) THEN
-           ctrcnm(jpc14)  = 'C14B'
-           ctrcnl(jpc14)  = 'Bomb C14 concentration'
+      IF( ctrcnm(jpc14) /= 'C14B' ) THEN
+          ctrcnm(jpc14)  = 'C14B'
+          ctrcnl(jpc14)  = 'Bomb C14 concentration'
       ENDIF
 
@@ -197,5 +193,5 @@
       ! ------------------
       IF( ctrcun(jpc14) /= 'ration' ) THEN
-          ctrcun(jpc14) = 'ration'
+          ctrcun(jpc14)  = 'ration'
           IF(lwp) THEN
              CALL ctl_warn( ' we force tracer unit' )
@@ -206,4 +202,5 @@
       !
    END SUBROUTINE trc_ctl_c14b
+   
 #else
    !!----------------------------------------------------------------------
Index: trunk/NEMOGCM/NEMO/TOP_SRC/C14b/trcnam_c14b.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/C14b/trcnam_c14b.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/C14b/trcnam_c14b.F90	(revision 2715)
@@ -16,5 +16,4 @@
    USE trc             ! TOP variables
    USE trcsms_c14b     ! C14b specific variable
-   USE in_out_manager  ! I/O manager
 
    IMPLICIT NONE
Index: trunk/NEMOGCM/NEMO/TOP_SRC/C14b/trcrst_c14b.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/C14b/trcrst_c14b.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/C14b/trcrst_c14b.F90	(revision 2715)
@@ -17,5 +17,4 @@
    USE trc             ! TOP variables
    USE trcsms_c14b          ! c14b sms trends
-   USE in_out_manager  ! I/O manager
    USE iom
 
Index: trunk/NEMOGCM/NEMO/TOP_SRC/C14b/trcsms_c14b.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/C14b/trcsms_c14b.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/C14b/trcsms_c14b.F90	(revision 2715)
@@ -4,7 +4,8 @@
    !! TOP : Bomb C14 main module
    !!======================================================================
-   !! History     -   ! 1994-05 ( J. Orr ) origial code
+   !! History     -   ! 1994-05 ( J. Orr ) original code
    !!            1.0  ! 2006-02 ( J.M. Molines )  Free form + modularity
    !!            2.0  ! 2008-12 ( C. Ethe ) reorganisation
+   !!            4.0  ! 2011-02 ( A.R. Porter, STFC Daresbury ) Dynamic memory
    !!----------------------------------------------------------------------
 #if defined key_c14b
@@ -12,20 +13,19 @@
    !!   'key_c14b'                                         Bomb C14 tracer
    !!----------------------------------------------------------------------
-   !!   trc_sms_c14b  :  compute and add C14 suface forcing to C14 trends
-   !!----------------------------------------------------------------------
-   USE oce_trc      ! Ocean variables
-   USE par_trc      ! TOP parameters
-   USE trc          ! TOP variables
+   !!   trc_sms_c14b :  compute and add C14 suface forcing to C14 trends
+   !!----------------------------------------------------------------------
+   USE oce_trc       ! Ocean variables
+   USE par_trc       ! TOP parameters
+   USE trc           ! TOP variables
    USE trdmod_oce
    USE trdmod_trc
-   USE iom
+   USE iom           ! I/O library
 
    IMPLICIT NONE
    PRIVATE
 
-   !! * Routine accessibility
-   PUBLIC   trc_sms_c14b       ! called in ???    
-
-   !! * Module variables
+   PUBLIC   trc_sms_c14b       ! called in trcsms.F90
+   PUBLIC   trc_sms_c14b_alloc ! called in trcini_c14b.F90
+
    INTEGER , PUBLIC, PARAMETER ::   jpmaxrec  = 240           ! temporal parameter 
    INTEGER , PUBLIC, PARAMETER ::   jpmaxrec2 = 2 * jpmaxrec  ! 
@@ -37,104 +37,91 @@
    INTEGER , PUBLIC    ::   nyear_beg        ! initial year (aa) 
 
-   REAL(wp), PUBLIC, DIMENSION(jpmaxrec,jpzon) ::  bomb   !: C14 atm data (3 zones)
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj ,jpzon) ::  fareaz !: Spatial Interpolation Factors
-   REAL(wp), PUBLIC, DIMENSION(jpmaxrec2)      ::  spco2  !: Atmospheric CO2
+   REAL(wp), PUBLIC,                    DIMENSION(jpmaxrec,jpzon) ::   bomb       !: C14 atm data (3 zones)
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)          ::   fareaz     !: Spatial Interpolation Factors
+   REAL(wp), PUBLIC,                    DIMENSION(jpmaxrec2)      ::   spco2      !: Atmospheric CO2
   
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj)     ::   qtr_c14      !: flux at surface
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj)     ::   qint_c14     !: cumulative flux
-
-   REAL(wp) :: xlambda, xdecay, xaccum       ! C14 decay coef.  
-
-   REAL(wp) ::   xconv1 = 1.0          ! conversion from to 
-   REAL(wp) ::   xconv2 = 0.01/3600.   ! conversion from cm/h to m/s: 
-   REAL(wp) ::   xconv3 = 1.0e+3       ! conversion from mol/l/atm to mol/m3/atm
-
-  !! * Substitutions
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)            ::   qtr_c14    !: flux at surface
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)            ::   qint_c14   !: cumulative flux
+
+   REAL(wp) ::   xlambda, xdecay, xaccum       ! C14 decay coef.  
+   REAL(wp) ::   xconv1 = 1._wp                ! conversion from to 
+   REAL(wp) ::   xconv2 = 0.01_wp / 3600._wp   ! conversion from cm/h to m/s: 
+   REAL(wp) ::   xconv3 = 1.e+3_wp             ! conversion from mol/l/atm to mol/m3/atm
+
+   !! * Substitutions
 #  include "top_substitute.h90"
 
-  !!----------------------------------------------------------------------
-  !!  TOP 1.0 , LOCEAN-IPSL (2005) 
-  !! $Header: /home/opalod/NEMOCVSROOT/NEMO/TOP_SRC/SMS/trcc14bomb.F90,v 1.2 2005/11/14 16:42:43 opalod Exp $ 
-  !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
-  !!----------------------------------------------------------------------
-
+   !!----------------------------------------------------------------------
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
+   !! $Header: /home/opalod/NEMOCVSROOT/NEMO/TOP_SRC/SMS/trcc14bomb.F90,v 1.2 2005/11/14 16:42:43 opalod Exp $ 
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
-  SUBROUTINE trc_sms_c14b( kt )
-     !!----------------------------------------------------------------------
-     !!                  ***  ROUTINE trc_sms_c14b  ***
-     !!
-     !! ** Purpose :   Compute the surface boundary contition on C14bomb
-     !!      passive tracer associated with air-mer fluxes and add it to 
-     !!      the general trend of tracers equations.
-     !!
-     !! ** Original comments from J. Orr :
-     !!
-     !!      Calculates the input of Bomb C-14 to the surface layer of OPA
-     !!
-     !!      James Orr, LMCE, 28 October 1992
-     !!
-     !!      Initial approach mimics that of Toggweiler, Dixon, & Bryan (1989)
-     !!      (hereafter referred to as TDB) with constant gas exchange,
-     !!      although in this case, a perturbation approach is used for
-     !!      bomb-C14 so that both the ocean and atmosphere begin at zero.
-     !!      This saves tremendous amounts of computer time since no
-     !!      equilibrum run is first required (i.e., for natural C-14).
-     !!      Note: Many sensitivity tests can be run with this approach and
-     !!            one never has to make a run for natural C-14; otherwise,
-     !!            a run for natural C-14 must be run each time that one
-     !!            changes a model parameter!
-     !!
-     !!
-     !!      19 August 1993: Modified to consider Atmospheric C-14 fom IPCC.
-     !!      That is, the IPCC has provided a C-14 atmospheric record (courtesy
-     !!      of Martin Heimann) for model calibration.  This model spans from
-     !!      preindustrial times to present, in a format different than that
-     !!      given by TDB.  It must be converted to the ORR C-14 units used
-     !!      here, although in this case, the perturbation includes not only
-     !!      bomb C-14 but changes due to the Suess effect.
-     !!
-     !!----------------------------------------------------------------------
-     !! * Arguments
-     INTEGER, INTENT( in ) ::   kt    ! ocean time-step index
-
-     !! * Local declarations
-     INTEGER ::  &
-       ji, jj, jk, jz
-
-     INTEGER ::   &
-       iyear_beg,              &
-       iyear_beg1, iyear_end1, &
-       imonth1, im1, im2,      &
-       iyear_beg2, iyear_end2, &
-       imonth2, in1, in2
-         
-     REAL(wp), DIMENSION(jpi,jpj) ::  & 
-       zatmbc14
-
-     REAL(wp), DIMENSION(jpzon)   ::  &
-       zonbc14              !: time interp atm C14
-
-     REAL(wp) ::     &
-       zpco2at              !: time interp atm C02
-
-     REAL(wp) ::     &      !: dummy variables
-       zt, ztp, zsk, &
-       zsol ,        &      !: solubility
-       zsch ,        &      !: schmidt number
-       zv2  ,        &      !: wind speed ( square)
-       zpv  ,        &      !: piston velocity 
-       zdemi, ztra
-#if defined key_diatrc  && defined key_iomput
-      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zw3d
-#endif
-      !!----------------------------------------------------------------------
-
-      IF( kt == nit000 )  THEN
-         ! Computation of decay coeffcient
-         zdemi   = 5730.
+   SUBROUTINE trc_sms_c14b( kt )
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE trc_sms_c14b  ***
+      !!
+      !! ** Purpose :   Compute the surface boundary contition on C14bomb
+      !!      passive tracer associated with air-mer fluxes and add it to 
+      !!      the general trend of tracers equations.
+      !!
+      !! ** Original comments from J. Orr :
+      !!
+      !!      Calculates the input of Bomb C-14 to the surface layer of OPA
+      !!
+      !!      James Orr, LMCE, 28 October 1992
+      !!
+      !!      Initial approach mimics that of Toggweiler, Dixon, & Bryan (1989)
+      !!      (hereafter referred to as TDB) with constant gas exchange,
+      !!      although in this case, a perturbation approach is used for
+      !!      bomb-C14 so that both the ocean and atmosphere begin at zero.
+      !!      This saves tremendous amounts of computer time since no
+      !!      equilibrum run is first required (i.e., for natural C-14).
+      !!      Note: Many sensitivity tests can be run with this approach and
+      !!            one never has to make a run for natural C-14; otherwise,
+      !!            a run for natural C-14 must be run each time that one
+      !!            changes a model parameter!
+      !!
+      !!
+      !!      19 August 1993: Modified to consider Atmospheric C-14 fom IPCC.
+      !!      That is, the IPCC has provided a C-14 atmospheric record (courtesy
+      !!      of Martin Heimann) for model calibration.  This model spans from
+      !!      preindustrial times to present, in a format different than that
+      !!      given by TDB.  It must be converted to the ORR C-14 units used
+      !!      here, although in this case, the perturbation includes not only
+      !!      bomb C-14 but changes due to the Suess effect.
+      !!
+      !!----------------------------------------------------------------------
+      USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
+      USE wrk_nemo, ONLY:   zatmbc14 => wrk_2d_1
+      USE wrk_nemo, ONLY:   zw3d     => wrk_3d_1
+      !
+      INTEGER, INTENT(in) ::   kt    ! ocean time-step index
+      !
+      INTEGER :: ji, jj, jk, jz     ! dummy loop indices 
+      INTEGER :: iyear_beg , iyear_beg1, iyear_end1 
+      INTEGER :: iyear_beg2, iyear_end2 
+      INTEGER :: imonth1, im1, in1 
+      INTEGER :: imonth2, im2, in2 
+      REAL(wp), DIMENSION(jpzon) :: zonbc14       !: time interp atm C14 
+      REAL(wp)                   :: zpco2at       !: time interp atm C02 
+      REAL(wp) :: zt, ztp, zsk      ! dummy variables
+      REAL(wp) :: zsol              ! solubility
+      REAL(wp) :: zsch              ! schmidt number
+      REAL(wp) :: zv2               ! wind speed ( square)
+      REAL(wp) :: zpv               ! piston velocity 
+      REAL(wp) :: zdemi, ztra
+      !!----------------------------------------------------------------------
+
+      IF( wrk_in_use(2, 1) .OR. wrk_in_use(3, 1) ) THEN
+         CALL ctl_stop('trc_sms_c14b : requested workspace arrays unavailable')   ;   RETURN
+      ENDIF
+
+      IF( kt == nit000 )  THEN         ! Computation of decay coeffcient
+         zdemi   = 5730._wp
          xlambda = LOG(2.) / zdemi / ( nyear_len(1) * rday )
          xdecay  = EXP( - xlambda * rdt )
-         xaccum  = 1.0 -  xdecay
+         xaccum  = 1._wp -  xdecay
       ENDIF
 
@@ -206,11 +193,7 @@
       !  (zonmean), computes area-weighted mean to give the atmospheric C-14
       !  ----------------------------------------------------------------
-      DO jj = 1, jpj
-         DO ji = 1, jpi
-            zatmbc14(ji,jj) =   zonbc14(1) * fareaz(ji,jj,1)  &
-                 &           +  zonbc14(2) * fareaz(ji,jj,2)  &
-                 &           +  zonbc14(3) * fareaz(ji,jj,3)
-         END DO
-      END DO
+      zatmbc14(:,:) = zonbc14(1) * fareaz(:,:,1)   &
+         &          + zonbc14(2) * fareaz(:,:,2)   &
+         &          + zonbc14(3) * fareaz(:,:,3)
       
       ! time interpolation of CO2 concentrations to it time step  
@@ -218,5 +201,5 @@
            &     + spco2(iyear_end2) * FLOAT( in2 ) ) / 6.
 
-      IF (lwp) THEN
+      IF(lwp) THEN
           WRITE(numout, *) 'time : ', kt, ' CO2 year begin/end :',iyear_beg2,'/',iyear_end2,   &
           &                ' CO2 concen : ',zpco2at 
@@ -238,7 +221,7 @@
                zsol = EXP( -60.2409 + 93.4517 / ztp  + 23.3585 * LOG( ztp ) + zsk * tsn(ji,jj,1,jp_sal) )
                ! convert solubilities [mol/(l * atm)] -> [mol/(m^3 * ppm)]
-               zsol = zsol * 1.0e-03
+               zsol = zsol * 1.e-03
             ELSE
-               zsol = 0.
+               zsol = 0._wp
             ENDIF
 
@@ -307,18 +290,32 @@
       CALL iom_put( "fdecay" , zw3d )
 #endif
-      IF( l_trdtrc ) THEN
-         CALL trd_mod_trc( tra(:,:,:,jpc14), jpc14, jptra_trd_sms, kt )   ! save trends
-      END IF
-
-    END SUBROUTINE trc_sms_c14b
+      IF( l_trdtrc )   CALL trd_mod_trc( tra(:,:,:,jpc14), jpc14, jptra_trd_sms, kt )   ! save trends
+
+      IF( wrk_not_released(2, 1) .OR.   &
+          wrk_not_released(3, 1) )   CALL ctl_stop('trc_sms_c14b : failed to release workspace arrays')
+      !
+   END SUBROUTINE trc_sms_c14b
+
+
+   INTEGER FUNCTION trc_sms_c14b_alloc()
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE trc_sms_c14b_alloc  ***
+      !!----------------------------------------------------------------------
+      ALLOCATE( fareaz  (jpi,jpj ,jpzon) ,     &
+         &      qtr_c14 (jpi,jpj)        ,     &
+         &      qint_c14(jpi,jpj)        , STAT=trc_sms_c14b_alloc )
+         !
+      IF( trc_sms_c14b_alloc /= 0 )   CALL ctl_warn('trc_sms_c14b_alloc: failed to allocate arrays')
+      !
+   END FUNCTION trc_sms_c14b_alloc
 
 #else
-    !!----------------------------------------------------------------------
-    !!   Default option                                         Dummy module
-    !!----------------------------------------------------------------------
+   !!----------------------------------------------------------------------
+   !!   Default option                                         Dummy module
+   !!----------------------------------------------------------------------
 CONTAINS
-  SUBROUTINE trc_sms_c14b( kt )       ! Empty routine
-    WRITE(*,*) 'trc_freons: You should not have seen this print! error?', kt
-  END SUBROUTINE trc_sms_c14b
+   SUBROUTINE trc_sms_c14b( kt )       ! Empty routine
+      WRITE(*,*) 'trc_freons: You should not have seen this print! error?', kt
+   END SUBROUTINE trc_sms_c14b
 #endif
 
Index: trunk/NEMOGCM/NEMO/TOP_SRC/CFC/trcini_cfc.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/CFC/trcini_cfc.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/CFC/trcini_cfc.F90	(revision 2715)
@@ -15,6 +15,5 @@
    USE par_trc         ! TOP parameters
    USE trc             ! TOP variables
-   USE trcsms_cfc          ! CFC sms trends
-   USE in_out_manager  ! I/O manager
+   USE trcsms_cfc      ! CFC sms trends
 
    IMPLICIT NONE
@@ -34,5 +33,4 @@
    !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
 
@@ -45,6 +43,6 @@
       !! ** Method  : - Read the namcfc namelist and check the parameter values
       !!----------------------------------------------------------------------
-      INTEGER  ::   ji, jj, jn, jl, jm, js
-      REAL(wp) ::   zyy  ,  zyd
+      INTEGER  ::  ji, jj, jn, jl, jm, js
+      REAL(wp) ::  zyy, zyd
       !!----------------------------------------------------------------------
 
@@ -53,13 +51,16 @@
       IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~'
 
+      !                                ! Allocate CFC arrays
+      IF( trc_sms_cfc_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'trc_ini_cfc: unable to allocate CFC arrays' )
+
 
       ! Initialization of boundaries conditions
       ! --------------------------------------- 
-      xphem (:,:)    = 0.e0
-      p_cfc(:,:,:)   = 0.e0
+      xphem (:,:)    = 0._wp
+      p_cfc(:,:,:)   = 0._wp
       
       ! Initialization of qint in case of  no restart 
       !----------------------------------------------
-      qtr_cfc(:,:,:) = 0.e0
+      qtr_cfc(:,:,:) = 0._wp
       IF( .NOT. ln_rsttr ) THEN    
          IF(lwp) THEN
@@ -67,8 +68,8 @@
             WRITE(numout,*) 'Initialization de qint ; No restart : qint equal zero '
          ENDIF
-         qint_cfc(:,:,:) = 0.e0
+         qint_cfc(:,:,:) = 0._wp
          DO jl = 1, jp_cfc
             jn = jp_cfc0 + jl - 1
-            trn     (:,:,:,jn) = 0.e0
+            trn(:,:,:,jn) = 0._wp
          END DO
       ENDIF
@@ -116,6 +117,5 @@
          WRITE(numout,*) ' Year   p11HN    p11HS    p12HN    p12HS '
          DO jn = 30, 100
-            WRITE(numout, '( 1I4, 4F9.2)')   &
-               &         jn, p_cfc(jn,1,1), p_cfc(jn,2,1), p_cfc(jn,1,2), p_cfc(jn,2,2)
+            WRITE(numout, '( 1I4, 4F9.2)') jn, p_cfc(jn,1,1), p_cfc(jn,2,1), p_cfc(jn,1,2), p_cfc(jn,2,2)
          END DO
       ENDIF
@@ -135,8 +135,7 @@
       END DO
       !
-
       IF(lwp) WRITE(numout,*) 'Initialization of CFC tracers done'
       IF(lwp) WRITE(numout,*) ' '
-
+      !
    END SUBROUTINE trc_ini_cfc
    
Index: trunk/NEMOGCM/NEMO/TOP_SRC/CFC/trcnam_cfc.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/CFC/trcnam_cfc.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/CFC/trcnam_cfc.F90	(revision 2715)
@@ -16,5 +16,4 @@
    USE trc             ! TOP variables
    USE trcsms_cfc      ! CFC specific variable
-   USE in_out_manager  ! I/O manager
 
    IMPLICIT NONE
Index: trunk/NEMOGCM/NEMO/TOP_SRC/CFC/trcrst_cfc.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/CFC/trcrst_cfc.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/CFC/trcrst_cfc.F90	(revision 2715)
@@ -17,5 +17,4 @@
    USE trc             ! TOP variables
    USE trcsms_cfc          ! CFC sms trends
-   USE in_out_manager  ! I/O manager
    USE iom
 
Index: trunk/NEMOGCM/NEMO/TOP_SRC/CFC/trcsms_cfc.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/CFC/trcsms_cfc.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/CFC/trcsms_cfc.F90	(revision 2715)
@@ -4,7 +4,7 @@
    !! TOP : CFC main model
    !!======================================================================
-   !! History :    -   !  1999-10  (JC. Dutay)  original code
-   !!             1.0  !  2004-03 (C. Ethe) free form + modularity
-   !!             2.0  !  2007-12  (C. Ethe, G. Madec)  reorganisation
+   !! History :  OPA  !  1999-10  (JC. Dutay)  original code
+   !!  NEMO      1.0  !  2004-03  (C. Ethe) free form + modularity
+   !!            2.0  !  2007-12  (C. Ethe, G. Madec)  reorganisation
    !!----------------------------------------------------------------------
 #if defined key_cfc
@@ -12,18 +12,19 @@
    !!   'key_cfc'                                               CFC tracers
    !!----------------------------------------------------------------------
-   !!   trc_sms_cfc     :  compute and add CFC suface forcing to CFC trends
-   !!   trc_cfc_cst :  sets constants for CFC surface forcing computation
-   !!----------------------------------------------------------------------
-   USE oce_trc      ! Ocean variables
-   USE par_trc      ! TOP parameters
-   USE trc          ! TOP variables
+   !!   trc_sms_cfc  :  compute and add CFC suface forcing to CFC trends
+   !!   trc_cfc_cst  :  sets constants for CFC surface forcing computation
+   !!----------------------------------------------------------------------
+   USE oce_trc       ! Ocean variables
+   USE par_trc       ! TOP parameters
+   USE trc           ! TOP variables
    USE trdmod_oce
    USE trdmod_trc
-   USE iom
+   USE iom           ! I/O library
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC   trc_sms_cfc       ! called in ???    
+   PUBLIC   trc_sms_cfc         ! called in ???    
+   PUBLIC   trc_sms_cfc_alloc   ! called in trcini_cfc.F90
 
    INTEGER , PUBLIC, PARAMETER ::   jpyear = 150   ! temporal parameter 
@@ -34,8 +35,8 @@
    INTEGER , PUBLIC    ::   npyear         ! Number of years read in CFC1112 file
    
-   REAL(wp), PUBLIC, DIMENSION(jpyear,jphem, 2    ) ::   p_cfc    ! partial hemispheric pressure for CFC          
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj)              ::   xphem    ! spatial interpolation factor for patm
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj     ,jp_cfc) ::   qtr_cfc  ! flux at surface
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj     ,jp_cfc) ::   qint_cfc ! cumulative flux 
+   REAL(wp), PUBLIC, DIMENSION(jpyear,jphem, 2    )      ::   p_cfc    ! partial hemispheric pressure for CFC
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   xphem    ! spatial interpolation factor for patm
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   qtr_cfc  ! flux at surface
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   qint_cfc ! cumulative flux 
 
    REAL(wp), DIMENSION(4,2) ::   soa   ! coefficient for solubility of CFC [mol/l/atm]
@@ -54,7 +55,6 @@
    !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
-
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -75,10 +75,12 @@
       !!                CFC concentration in pico-mol/m3
       !!----------------------------------------------------------------------
-      INTEGER, INTENT( in ) ::   kt    ! ocean time-step index
-      !!
-      INTEGER ::   ji, jj, jn, jl, jm, js
-      INTEGER ::   iyear_beg, iyear_end
-      INTEGER ::   im1, im2
-
+      USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
+      USE wrk_nemo, ONLY:   ztrcfc => wrk_3d_1        ! use for CFC sms trend
+      !
+      INTEGER, INTENT(in) ::   kt    ! ocean time-step index
+      !
+      INTEGER  ::   ji, jj, jn, jl, jm, js
+      INTEGER  ::   iyear_beg, iyear_end
+      INTEGER  ::   im1, im2
       REAL(wp) ::   ztap, zdtap        
       REAL(wp) ::   zt1, zt2, zt3, zv2
@@ -88,8 +90,10 @@
       REAL(wp) ::   zca_cfc   ! concentration at equilibrium
       REAL(wp) ::   zak_cfc   ! transfert coefficients
-
-      REAL(wp), DIMENSION(jphem,jp_cfc)   ::   zpatm       ! atmospheric function
-      REAL(wp), DIMENSION(jpi,jpj,jpk)    ::   ztrcfc      ! use for CFC sms trend
-      !!----------------------------------------------------------------------
+      REAL(wp), DIMENSION(jphem,jp_cfc) ::   zpatm   ! atmospheric function
+      !!----------------------------------------------------------------------
+      !
+      IF( wrk_in_use(3, 1) ) THEN
+         CALL ctl_stop('trc_sms_cfc: requested workspace array unavailable')   ;   RETURN
+      ENDIF
 
       IF( kt == nit000 )   CALL trc_cfc_cst
@@ -175,10 +179,10 @@
 #if defined key_diatrc 
       ! Save diagnostics , just for CFC11
-# if ! defined key_iomput
+# if  defined key_iomput
+      CALL iom_put( "qtrCFC11"  , qtr_cfc (:,:,1) )
+      CALL iom_put( "qintCFC11" , qint_cfc(:,:,1) )
+# else
       trc2d(:,:,jp_cfc0_2d    ) = qtr_cfc (:,:,1)
       trc2d(:,:,jp_cfc0_2d + 1) = qint_cfc(:,:,1)
-# else
-      CALL iom_put( "qtrCFC11"  , qtr_cfc (:,:,1) )
-      CALL iom_put( "qintCFC11" , qint_cfc(:,:,1) )
 # endif
 #endif
@@ -190,6 +194,9 @@
           END DO
       END IF
-
+      !
+      IF( wrk_not_released(3, 1) )   CALL ctl_stop('trc_sms_cfc: failed to release workspace array')
+      !
    END SUBROUTINE trc_sms_cfc
+
 
    SUBROUTINE trc_cfc_cst
@@ -200,45 +207,57 @@
       !!---------------------------------------------------------------------
 
-
-        ! coefficient for CFC11 
-        !----------------------
-
-        ! Solubility
-        soa(1,1) = -229.9261 
-        soa(2,1) =  319.6552
-        soa(3,1) =  119.4471
-        soa(4,1) =  -1.39165
-
-        sob(1,1) =  -0.142382
-        sob(2,1) =   0.091459
-        sob(3,1) =  -0.0157274
-
-        ! Schmidt number 
-        sca(1,1) = 3501.8
-        sca(2,1) = -210.31
-        sca(3,1) =  6.1851
-        sca(4,1) = -0.07513
-
-        ! coefficient for CFC12 
-        !----------------------
-
-        ! Solubility
-        soa(1,2) = -218.0971
-        soa(2,2) =  298.9702
-        soa(3,2) =  113.8049
-        soa(4,2) =  -1.39165
-
-        sob(1,2) =  -0.143566
-        sob(2,2) =   0.091015
-        sob(3,2) =  -0.0153924
-
-        ! schmidt number 
-        sca(1,2) =  3845.4 
-        sca(2,2) =  -228.95
-        sca(3,2) =  6.1908 
-        sca(4,2) =  -0.067430
+      ! coefficient for CFC11 
+      !----------------------
+
+      ! Solubility
+      soa(1,1) = -229.9261 
+      soa(2,1) =  319.6552
+      soa(3,1) =  119.4471
+      soa(4,1) =  -1.39165
+
+      sob(1,1) =  -0.142382
+      sob(2,1) =   0.091459
+      sob(3,1) =  -0.0157274
+
+      ! Schmidt number 
+      sca(1,1) = 3501.8
+      sca(2,1) = -210.31
+      sca(3,1) =  6.1851
+      sca(4,1) = -0.07513
+
+      ! coefficient for CFC12 
+      !----------------------
+
+      ! Solubility
+      soa(1,2) = -218.0971
+      soa(2,2) =  298.9702
+      soa(3,2) =  113.8049
+      soa(4,2) =  -1.39165
+
+      sob(1,2) =  -0.143566
+      sob(2,2) =   0.091015
+      sob(3,2) =  -0.0153924
+
+      ! schmidt number 
+      sca(1,2) =  3845.4 
+      sca(2,2) =  -228.95
+      sca(3,2) =  6.1908 
+      sca(4,2) =  -0.067430
 
    END SUBROUTINE trc_cfc_cst
-   
+
+
+   INTEGER FUNCTION trc_sms_cfc_alloc()
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE trc_sms_cfc_alloc  ***
+      !!----------------------------------------------------------------------
+      ALLOCATE( xphem   (jpi,jpj)        ,     &
+         &      qtr_cfc (jpi,jpj,jp_cfc) ,     &
+         &      qint_cfc(jpi,jpj,jp_cfc) , STAT=trc_sms_cfc_alloc )
+         !
+      IF( trc_sms_cfc_alloc /= 0 ) CALL ctl_warn('trc_sms_cfc_alloc : failed to allocate arrays.')
+      !
+   END FUNCTION trc_sms_cfc_alloc
+
 #else
    !!----------------------------------------------------------------------
